unit FNCChartTestUnit;

interface

uses
  Classes, VCL.TMSFNCChart, VCL.TMSFNCChartEditor, StdCtrls, ExtCtrls, Controls, Forms, VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, UITypes, SysUtils, DateUtils,
  Math, Dialogs, Graphics, VCL.TMSFNCTypes, VCL.TMSFNCUtils;

type
  TForm1 = class(TForm)
    Chart1: TTMSFNCChart;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure BuildChart;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BuildChart;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  BuildChart;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  BuildChart;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  BuildChart;
end;

procedure TForm1.BuildChart;
var i,j: integer;
    s: TTMSFNCChartSerie;
    f: Boolean;
begin
  if (CheckBox1.Checked = false) and (CheckBox2.Checked = false) and (CheckBox3.Checked = false) then
    begin
      Chart1.BeginUpdate;
      Chart1.Clear;
      Chart1.Title.Text := 'No Data Selected';
      Chart1.Title.Font.Name := 'Verdana';
      Chart1.Title.Font.Style := Chart1.Title.Font.Style + [TFontStyle.fsBold];
      Chart1.Title.Font.Color := clBlack;
      Chart1.Title.Font.Size := 14;
      Chart1.Title.Stroke.Color := $00CFCFCF;
      Chart1.Title.TextHorizontalAlignment := gtaCenter;
      Chart1.Legend.Visible := false;
      Chart1.XAxis.Visible := false;
      Chart1.YAxis.Visible := false;
      Chart1.Series.Clear;
      Chart1.EndUpdate;
    end
  else
    begin
      Chart1.BeginUpdate;
      Chart1.Clear;
      Chart1.Title.Text := 'Monthly Car Sales';
      Chart1.Title.Font.Name := 'Verdana';
      Chart1.Title.Font.Style := Chart1.Title.Font.Style + [TFontStyle.fsBold];
      Chart1.Title.Font.Color := clBlue;
      Chart1.Title.Font.Size := 14;
      Chart1.Title.Stroke.Color := $00CFCFCF;
      Chart1.Title.TextHorizontalAlignment := gtaCenter;
      Chart1.Legend.Position := lpTopRight;
      Chart1.Legend.Left := -10;
      Chart1.Legend.Font.Name := 'Tahoma';
      Chart1.Legend.Font.Size := 8;
      Chart1.Legend.Visible := true;
      Chart1.Legend.Font.Color := clBlack;
      Chart1.Legend.Stroke.Color := clBlack;
      Chart1.XAxis.Visible := true;
      Chart1.YAxis.Visible := true;
      Chart1.YAxis.Positions := [ypLeft];
      Chart1.XAxis.Positions := [xpBottom];
      Chart1.SeriesMargins.Left := 0;
      Chart1.SeriesMargins.Top := 0;
      Chart1.SeriesMargins.Right := 0;
      Chart1.SeriesMargins.Bottom := 0;
      Chart1.Series.Clear;
      for i := 0 to 2 do
        begin
          s := Chart1.Series.Add;
          s.XValues.Title.Text := 'Month';
          s.XValues.Title.TextHorizontalAlignment := gtaCenter;
          s.XValues.Title.Font.Color := clBlack;
          s.XValues.Title.Font.Size := 14;
          s.XValues.Title.Font.Style := s.YValues.Title.Font.Style + [TFontStyle.fsBold];
          s.XValues.Title.TextMargins.Right := 10;
          s.YValues.Title.Text := 'Number of Cars';
          s.YValues.Title.TextVerticalAlignment := gtaCenter;
          s.YValues.Title.Font.Color := clBlack;
          s.YValues.Title.Font.Size := 14;
          s.YValues.Title.Font.Style := s.YValues.Title.Font.Style + [TFontStyle.fsBold];
          s.YValues.Positions := [ypLeft];
          s.XValues.Positions := [xpBottom];
          s.XGrid.Visible := true;
          s.YGrid.Visible := true;
          s.AutoXRange := arDisabled;
          s.AutoYRange := arDisabled;
          s.MinX := -0.25;
          s.MaxX := 11.25;
          s.MinY := 0;
          s.MaxY := 300;
          s.Mode := smStatistical;
          s.ChartType := ctBar;
          case i of
            0:
              begin
                s.LegendText := 'Mercedes';
                s.Fill.Kind := gfkGradient;
                s.Fill.Orientation := gfoHorizontal;
                s.Fill.Color := gcLightslategray;
                s.Fill.ColorTo := gcDarkslategray;
                s.Stroke.Color := gcBlack;
                s.Labels.Font.Color := gcWhite;
              end;
            1:
              begin
                s.LegendText := 'Bugatti';
                s.Fill.Kind := gfkGradient;
                s.Fill.Orientation := gfoHorizontal;
                s.Fill.Color := gcOrange;
                s.Fill.ColorTo := gcOrangered;
                s.Stroke.Color := gcDarkred;
              end;
            2:
              begin
                s.LegendText := 'Audi';
                s.Fill.Kind := gfkGradient;
                s.Fill.Orientation := gfoHorizontal;
                s.Fill.Color := gcLimegreen;
                s.Fill.ColorTo := gcGreenyellow;
                s.Stroke.Color := gcDarkgreen;
              end;
          end;
          s.Bar.Spacing := 0;
          s.Labels.Fill.Color := s.Fill.Color;
          s.Labels.Stroke.Color := s.Stroke.Color;
          s.YValues.MajorUnitFormat := '%g';
          s.Labels.Visible := true;
          s.Labels.Format := '%g';
          s.YValues.MajorUnitFont.Size := 8;
          s.YValues.MinorUnitFont.Size := 8;
          s.XValues.MajorUnitFont.Color := clBlack;
          s.XValues.MajorUnitTickMarkColor := gcDarkslategray;
          s.YValues.MajorUnitFont.Color := clBlack;
          s.YValues.MajorUnitTickMarkColor := gcDarkslategray;
          for j := 1 to 12 do s.AddPoint(RandomRange(50,250),FormatSettings.LongMonthNames[j]);
        end;
      if CheckBox1.Checked then Chart1.Series[0].Visible := true else Chart1.Series[0].Visible := false;
      if CheckBox2.Checked then Chart1.Series[1].Visible := true else Chart1.Series[1].Visible := false;
      if CheckBox3.Checked then Chart1.Series[2].Visible := true else Chart1.Series[2].Visible := false;


      f := False;
      for I := 0 to Chart1.Series.Count - 1 do
      begin
        if Chart1.Series[I].Visible and not f then
        begin
          Chart1.Series[I].YValues.Positions := [ypLeft];
          Chart1.Series[I].XValues.Positions := [xpBottom];
          f := True;
        end
        else
        begin
          Chart1.Series[I].YValues.Positions := [];
          Chart1.Series[I].XValues.Positions := [];
        end;
      end;

      Chart1.EndUpdate;
    end;
end;


end.
